#include "sini.h"

#define schar signed char
#define sint signed int
#define uint unsigned int

extern int LINEINNER(char *bufu,int vari,int deltax,sint sta1m,sint sta2,uint steppi);
extern signed int DIV32(signed int a, signed int b);

unsigned char xet[40],xh[40],rt1[512],rt2[512];

sint x0,x1,c0,c1;
sint dx0,dx1,dc0,dc1,cstep;

int lzkur;
signed char *tau3d_ptz;
signed int cstep;

char pal[3][16] =

      {0x00,0x00,0x00,0x01,   /* punainen */
       0x04,0x40,0x44,0x45,
       0x4c,0xc4,0xcc,0xce,
       0xec,0xee,0xee,0xee,

       0x00,0x00,0x00,0x01,   /* vihre */
       0x02,0x02,0x20,0x20,
       0x22,0x22,0x2a,0x2a,
       0xa2,0xa2,0xaa,0xab,

       0x00,0x00,0x00,0x01,   /* sininen */
       0x01,0x10,0x11,0x13,
       0x19,0x91,0x99,0x9b,
       0xb9,0xbb,0xbf,0xfb };

signed int x[50],y[50],z[50],v[50];
char polyh[60][4];

char points,polys;

char ytbuf[3][80];

extern char *ruutu;


/*************************** 3D-ENGiNE *******************************/

int xr1tsf,xr2tsf,cr1tsf,cr2tsf;

pyorayta(char k1,char k2,char k3,int posx,int posy,char kzoom)
{
      signed char *s;
      signed int  x0,y0,z0, A,B;
      signed int  x1,y1,z1, x2,y2,z2;
      signed char c0,s0,c1,s1,c2,s2;

      char l;int t;

      s=tau3d_ptz;

	    c0=sini[(k1+64)&255];s0=sini[k1&255];
	    c1=sini[(k2+64)&255];s1=sini[k2&255];
	    c2=sini[(k3+64)&255];s2=sini[k3&255];

      for(l=0;l<points;l++){

            x0=*s;s++;
            y0=*s;s++;
	    z0=*s;s++;

/*    A=c0*x0;B=s0*y0;                    z

      x1=(A+B)>>7;
      y1=((c0-s0)*(x0+y0)-A+B)>>7; */

      x1=(c0*x0+s0*y0)>>7;
      y1=(c0*y0-s0*x0)>>7;

/*    A=c1*x1;B=s1*z0;
      x2=(A+B)>>7;
      z1=((c1-s1)*(x1+z0)-A+B)>>7; */

      x2=(c1*x1+s1*z0)>>7;
      z1=(c1*z0-s1*x1)>>7;

/*    A=c2*y1;B=s2*z1;
      y2=(A+B)>>8;
      z2=((c2-s2)*(y1+z1)-A+B)>>8; */

      y2=(c2*y1+s2*z1)>>8;
      z2=(c2*z1-s2*y1)>>8;

      if (kzoom) {
	    x2=(x2*kzoom)>>6;
	    y2=(y2*kzoom)>>6; }

	    x[l]=(x2>>2)+posx;
	    y[l]=(y2>>1)+posy;
	    z[l]=z2;

	  t=abs(z1+48)*2;if (t>255) t=255; v[l]=t;
}}

qcomp(signed int *i,signed int *j)
{return *i-*j;}

piirra3d()
{
      signed int srtpol[4*60],*s; signed char *t;
      signed int l,fn;

      s=srtpol;t=polyh[0];
      for(l=0;l<polys;l++) {*s=z[*t++]
			      +z[*t++]
			      +z[*t++];t++;s++;*s=l;s++;}
      qsort(srtpol,polys,4,qcomp);

      s=srtpol+1;
      for(l=polys;l;l--) {
            fn=*s;s+=2;t=polyh[fn];

            polyta( x[*(t+0)],y[*(t+0)],v[*(t+0)],
                    x[*(t+1)],y[*(t+1)],v[*(t+1)],
                    x[*(t+2)],y[*(t+2)],v[*(t+2)],
                    *(t+3));
            }
}


      /* gouraudipolyn piirtorutiini.
         ei osaa hoitaa ruudun sivurajojen yli menevi ptepisteit */

polyta(sint KX0,sint KY0,schar KC0,
       sint KX1,sint KY1,schar KC1,
       sint KX2,sint KY2,schar KC2, char palno)
{
      signed long int tp;signed int t,tmp;
      schar kxb,xjrj;

      if (KY0>KY1) { tmp=KY0;KY0=KY1;KY1=tmp;         /* y-sorttaus */
                     tmp=KX0;KX0=KX1;KX1=tmp;
                     tmp=KC0;KC0=KC1;KC1=tmp; }
      if (KY1>KY2) { tmp=KY1;KY1=KY2;KY2=tmp;
                     tmp=KX1;KX1=KX2;KX2=tmp;
                     tmp=KC1;KC1=KC2;KC2=tmp; }
      if (KY0>KY1) { tmp=KY0;KY0=KY1;KY1=tmp;
                     tmp=KX0;KX0=KX1;KX1=tmp;
                     tmp=KC0;KC0=KC1;KC1=tmp; }

/*       if (KX1<KX2) xjrj=0; else xjrj=1; */

      if ((KY0==KY1) && (KY1==KY2)) {}

      else{

      if (KY0!=KY1) {   /* piikkihuippu: p0 ja p1 -puolet omiaan pin */

	    x0=KX0<<7;x1=KX0<<7;                c0=KC0<<8;c1=KC0<<8;

	    dx0=((KX1-KX0)<<7)/(KY1-KY0);	dc0=((KC1-KC0)<<8)/(KY1-KY0);

	    dx1=((KX2-KX0)<<7)/(KY2-KY0); 	dc1=((KC2-KC0)<<8)/(KY2-KY0);

	    if (dx1!=dx0){
	    if ((dx1-dx0)>>8) cstep=(dc1-dc0)/((dx1-dx0)>>8); else
			      cstep=((dc1-dc0)<<8)/(dx1-dx0);
	    }

	    /*if (dx1!=dx0)  cstep=DIV32(dc1-dc0,dx1-dx0);*/

	    puolikolmio(KY0,KY1,palno);

      } else {          /* tasahuippu: p1-puoli p1:ta pin (p0 seur:ssa) */

	    x0=KX0<<7; x1=KX1<<7;		c0=KC0<<8; c1=KC1<<8;

            dx1=((KX2-KX1)<<7)/(KY2-KY0); dc1=((KC2-KC1)<<8)/(KY2-KY0);

	    if (x1!=x0) {
	    if ((x1-x0)>>8)   cstep=(c1-c0)/((x1-x0)>>8); else
			      cstep=((c1-c0)<<8)/(x1-x0);
	    }/* tai div32 */

	    }

      if (KY1!=KY2) {   /* piikkipohja: p0-puoli p1:ta pin */

	    dx0=((KX2<<7)-x0)/(KY2-KY1);	dc0=((KC2<<8)-c0)/(KY2-KY1);

            puolikolmio(KY1,KY2,palno);

            }
      }
}

puolikolmio(sint y,sint yl, char palno)
{
      char c,x;
      char *outti,*palli; signed int t; signed long int tp;

      outti=ruutu+(y*160);
      palli=pal[palno];

      for(;y<yl;y++) {

            x0+=dx0;  x1+=dx1;
	    c0+=dc0;  c1+=dc1;      /* tarvitaanko c1/dc1:t yleens? */

	    /*if ((x1-x0)>>8) cstep=(c1-c0)/((x1-x0)>>8);*/

            if (outti>=ruutu) if (outti<=ruutu+32000) {
	      if (x1>x0)   GRD_ROW(outti,palli,x0*2,x1*2,c0,cstep);
		      else GRD_ROW(outti,palli,x1*2,x0*2,c1,cstep); }

            outti+=160;
}	}

lataa3d(char *stru)
{
      char l,*s,fr;
      polys=*stru;stru++;
      points=*stru;stru++;
      tau3d_ptz=stru;stru+=(points*3);

      s=polyh[0];for(l=0;l<polys*4;l++) {*s=*stru;s++;stru++;}
}
