#include <stdio.h>
#include "dos.h"

void interrupt int_8();
void interrupt (*old_int8)();

unsigned char sumptyp[4] = { 0,1,0,1 };
	/* bass1
	   twnkick
	   twnsnr
	   windy */
unsigned char sumpt2[3] = { 0,0,1 };

char sumples[3][9] =

{
    0xa0,0xa0,0xa7,0x77,0x00,0x00,0x0d,0x0e,0x02,  /* bass? */
    0xa4,0x28,0xff,0xff,0x00,0x00,0x0d,0x0c,0x03, /* ohrgan */
    0x80,0xc1,0xd7,0xe1,0xd5,0xc1,0x54,0xb0,0x04 /* rummuke */
	};

 /*  0x81,0x00,0xe6,0xe5,0x25,0x25,0x08,0x0d,0x02,      tum
  0x80,0x04,0xa1,0xa6,0x60,0xb5,0xe6,0x31,0x0e,     slh */

/*   0xa8,0x26,0xff,0xff,0x00,0x00,0x0d,0x0c,0x03   ohrgan */

/*    0x54,0x67,0x00,0x1e,0x30,0x20,0xe9,0xa6,0xd7,0xcd,0xb9,
      0x00,0x00,0x00,0x00,0xc4,0xd5,0x25,0x75,0x33,0x33,0x02,
      0x15,0xb5,0x49,0x01,0xbe,0xe0,0x2b,0x2a,0x91,0x25,0x03,
      0x00,0x00,0x00,0x00,0xc4,0xd5,0x25,0x75,0x33,0x33,0x02,
      0x0b,0x10,0x80,0x80,0x76,0x6f,0xc5,0x72,0xfb,0x93,0x0f,
      0x15,0xb1,0x49,0x01,0xbe,0xe0,0x2b,0x2a,0x91,0x25,0x03
*/

/*
{
      0xe4,0xf5,0x97,0x85,0xa5,0x60,0x02,0x15,0x0a,0x9b,0x54,
      0x0d,0x11,0x80,0x80,0x76,0x6f,0xc5,0x72,0xfb,0x93,0x0f,
      0xe4,0xf5,0x97,0x85,0xa5,0x60,0x02,0x15,0x0a,0x9b,0x54,
      0x00,0x00,0x00,0x00,0xc4,0xd5,0x25,0x75,0x33,0x33,0x02,
      0x1e,0x35,0xd5,0x43,0x24,0x66,0x13,0x00,0x3b,0x1c,0x03 };
*/

/*
{     0x64,0xd0,0x0a,0xc2,0x56,0xd0,0x65,0x30,0xa0,0x0c,

      0x1e,0x35,0xd5,0x43,0x24,0x66,0x13,0x00,0x3b,0x1c,
      0x74,0xf5,0x14,0x07,0xa7,0xc4,0xe2,0x7d,0x80,0x72,
      0x15,0xb1,0x49,0x01,0xbe,0xe0,0x2b,0x2a,0x91,0x25 }; */

char patord[128];
unsigned char adlmem[256];

/* a0 : 0
   b0 : 1
   vol: 2
   samp:3
   eff: 4  - jrj muuttunut! */

char trax[10][64][4][5];

/* char a0[13][4][64],b0[13][13][64],vol[13][4][64],samp[13][4][64],eff[13][4][64]; */

int freku[48] = {

		0x157/2,0x16b/2,0x181/2,0x198/2,0x1b0/2,0x1ca/2,
		 0x1e5/2,0x202/2,0x220/2,0x241/2,0x263/2,0x287/2,

		0x157,0x16b,0x181,0x198,0x1b0,0x1ca,
		 0x1e5,0x202,0x220,0x241,0x263,0x287,

		0x157*2,0x16b*2,0x181*2,0x198*2,0x1b0*2,0x1ca*2,
		 0x1e5*2,0x202*2,0x220*2,0x241*2,0x263*2,0x287*2,

		 0x157*4,0x16b*4,0x181*4,0x198*4,0x1b0*4,0x1ca*4,
		 0x1e5*4,0x202*4,0x220*4,0x241*4,0x263*4,0x287*4

		 };

int apufreku[3][4];
char apuokt[4][4];
char aliaskel;

char jookt[4],jonuot[4];

            /* stm-orderin mukaan: 0,1,2,3 upto B */

char cord,cpatti,ckohta;

char alilasku;

huukkaa()
{
      disable();
      old_int8=getvect(0x08);
      setvect(0x08,int_8);
      enable();
}

unhuukkaa()
{
      disable();
      setvect(0x08,old_int8);
}

void interrupt int_8()
{
      (*old_int8)();
      alilasku=(alilasku+1)&3;
}

kellovauhti(char spiidi)
{
      disable();
      outportb(0x43,0x36);
      outportb(0x40,0x00);
      outportb(0x40,spiidi);
      enable();
}

luestm()
{
      FILE *stm;
      int l,l2,l3;
      char maxp;
      char okt,nuot,snum,vlo,vhi,efkod,vlu,efbyte;
      char josmp[4],jovol[4];

      stm=fopen("lamu2.stm","rb");

      maxp=0;
      for(l=0x410;l;l--) fgetc(stm);
      cprintf("\n\rOhitettu 0x410 asti");
      cprintf("\n\rOrderi: ");
      for(l=0;l<128;l++) {
            patord[l]=fgetc(stm);
            if (patord[l]<99) if (patord[l]>maxp) maxp=patord[l];
            cprintf("%i - ",patord[l]);
      }

      maxp++; cprintf("\n\rPatternien mr: %i",maxp);
      cprintf("\n\rLuetaan patternit: ");

      for(l2=0;l2<4;l2++) { josmp[l2]=0xff; jovol[l2]=0xff; }

      for(l=0;l<maxp;l++) {

	    if (l<3) for(l2=0;l2<4;l2++) josmp[l2]=0xff;

	    cprintf("%i..",l);

      for(l2=0;l2<64;l2++)
      for(l3=0;l3<4;l3++)
      {
            vlu=fgetc(stm);   okt=(vlu>>4);
			      nuot=vlu&15;	/* nuot: f=sama */
	    vlu=fgetc(stm);   snum=vlu>>3;	/* numerot 1..x, 0=sama */
			      vlo=vlu&7;        /* volumet 0..64, "sama"=? */
            vlu=fgetc(stm);   vhi=vlu>>4;
			      efkod=(vlu&15)<<4;
	    efbyte=fgetc(stm);


			/* TAAJUUS JNE */

	    okt+=sumptyp[josmp[l3]];
	    if (nuot!=0x0f) {
               jookt[l3]=trax[l][l2][l3][0]=(okt)*16+nuot;
	    } else
	       trax[l][l2][l3][0]=0xff;

	    vlu=(vlo+(8*vhi))|1;
            if (vlu<2) trax[l][l2][l3][0]=0xfe;

      }}

      cprintf("\n\rPatternit luettu!");
      fclose(stm);
}


kirjstm()
{
	FILE *stm;
	int l,l2,l3,l4;

	cprintf("\n\rKirjotettaan alas stmfile!");

        stm=fopen("tu2_musa.h","w");

	fprintf(stm,"\n\runsigned char trax[6][64][4][5]");

        for(l=0;l<14;l++)
            fprintf(stm,"%i,",patord[l]);

        for(l=0;l<8;l++) {
                fprintf(stm,"\n\rPATTERNi %i\n\r",l);
                cprintf("\n\r%i...",l);
	for(l2=0;l2<64;l2++) {
		fprintf(stm,"\n\r");
                cprintf("%i ",l2);
	for(l3=0;l3<2;l3++) {
                fprintf(stm,"0x%x,",trax[l][l2][l3][0]);
        }}}

	fclose(stm);
}

adlib(unsigned char reg,unsigned char sis)
{
      char l;
      if (adlmem[reg]!=sis) {
      outportb(0x388,reg); /* for(l=7;l;l--) inportb(0x388); */
      outportb(0x389,sis); /* for(l=36;l;l--) inportb(0x389); */
      }
}

instaus()
{
      unsigned char ll,s1,s2;
      for(ll=0;ll<240;ll++) adlmem[ll]=0xfe;
      adlib(4,0x60); adlib(4,0x80); /* s1=inportb(0x388); */
      adlib(2,0xff); adlib(4,0x21); /* s2=inportb(0x388); */
      adlib(4,0x60); adlib(4,0x80);
      for(ll=0;ll<240;ll++) adlib(ll,0);
/*      if (((s1&0xe0)==0x00) && ((s2&0xe0)==0xc0)) return 1; else return 0; */
}

uusinuotti()
{
      int l,ll,freki;
      signed int lask;
      char vm,kn,mk,poh;
      char jutohi,ednuot;
      char outto[4] = {0,1,2,8};
      char osotte[9] =
      { 0x20,0x23,0x60,0x63,0x80,0x83,0xe0,0xe3,0xc0 };

      unsigned char *p;

      poh=5+(ckohta&15);

      gotoxy(1,5+poh);cprintf("%x:%i  ",cpatti,ckohta);
      jutohi=0;

      if (aliaskel==0) {
      for(l=0;l<4;l++) {
	    gotoxy(7+(l*18),5+poh);
	    cprintf("%x:%x - %x %x %x  ",
	       trax[cpatti][ckohta][l][0],
	       trax[cpatti][ckohta][l][1],
	       trax[cpatti][ckohta][l][2],
	       trax[cpatti][ckohta][l][3],
	       trax[cpatti][ckohta][l][4]);

	    p=trax[cpatti][ckohta][l];

	    vm=0; kn=outto[l];

	    mk=*(p+3);
            if (mk!=0xff) {                     /* samplenvaihto */
		  adlib(0xa0+l,0);
		  adlib(0xb0+l,0);
                  for(ll=0;ll<8;ll++) adlib(osotte[ll]+kn,sumples[mk][ll]);
		  adlib(osotte[8]+l,sumples[mk][8]);
	    }

	    if (*(p+2)!=0xff) vm=1;

	    /* ednuot=jonuot[l]; */

            apuokt[0][l]=*p;      apufreku[0][l]=freku[*(p+1)];
            apuokt[1][l]=
            apuokt[2][l]=
            apuokt[3][l]=0xff;    jonuot[l]=*(p+1);


              if (((*(p+4))&0xf0)==0xa0) {      /* ARPEGGiO */

                apuokt[1][l]=
                apuokt[2][l]=
                apuokt[3][l]=apuokt[0][l];

                apufreku[1][l]=
		apufreku[3][l]=freku[jonuot[l]+(*(p+4)&15)];

                apufreku[2][l]=apufreku[0][l];

		}

		/*

	      if (((*(p+4))&0xf0)==0x70) {          TONESLiDE

                apuokt[1][l]=
                apuokt[2][l]=
		apuokt[3][l]=apuokt[0][l];

		apufreku[3][l]=apufreku[0][l];

		freki=freku[ednuot];
		lask=(apufreku[0][l]-freki)/2;

		apufreku[2][l]=freki+lask;
		apufreku[0][l]=freki;

	    } */

	    if (*p!=0xff) {			/* taajuus */
               adlib(0xb0+l,(apufreku[0][l]>>8)|32|apuokt[0][l]);
               adlib(0xa0+l,apufreku[0][l]&255);
            }

	    if (vm==1) {			/* volset */
		  adlib(0x40+kn,*(p+2));
		  adlib(0x43+kn,*(p+2));
            }

	    if (*(p+4)==0x30) jutohi=1;

      }

      ckohta++; if (ckohta==64) jutohi=1;
      }

      if (aliaskel>0) {
	for(l=0;l<4;l++)
		if (apuokt[aliaskel][l]!=0xff) {
		  kn=outto[l];
                  adlib(0xb0+l,(apufreku[aliaskel][l]>>8)|32|apuokt[aliaskel][l]);
                  adlib(0xa0+l,apufreku[aliaskel][l]&255);
		  }
	}

      if (jutohi) {
		ckohta=0; cord++;
		cpatti=patord[cord];
		if (cpatti==99) { cord=0; cpatti=patord[cord]; }}

      aliaskel=(aliaskel+1)&3;

}

main()
{
      char l1,l2;
      int pikpoi;

      luestm();
      kirjstm();

      getch();

      /*
      clrscr();
      instaus();

      pikpoi=0;cord=0;cpatti=patord[cord];ckohta=0;aliaskel=0;
      for(l1=0;l1<4;l1++) { jookt[l1]=0xff; jonuot[l1]=0xff; }

      huukkaa();
      kellovauhti(64);

      while(!kbhit()) {
	    if ((alilasku&128)==0) {
		 pikpoi++; if (pikpoi==1) { uusinuotti(); pikpoi=0; }
                  alilasku|=128;
		  }
	    }

      instaus();

      kellovauhti(0);
      unhuukkaa();
      */
}
