_ALLO64K:               ; ALLO64K();

push bx
mov ah,048
mov bx,4095             ; "vhn vaille 64k"
int 021
if c xor ax,ax          ; palauttaa nollan jos ei onnistunut
pop bx                  ; muussatapauksessa segmentin numeron
retf

_SCRMODE:               ; SCRMODE(int monesko);
push bp
mov bp,sp
mov ax,[bp+6]
push bx
xor bx,bx
int 010
pop bx,bp
xor ax,ax
retf

_MSFREE:                ; MSFREE(int segment);
push bp
mov bp,sp
push es
mov ax,[bp+6]
mov es,ax
mov ah,049
int 021
pop es,bp
retf

_ALLOTEST:      ; (int *buffer) returns int buff_offset from seg

push bp
mov bp,sp
mov ax,[bp+6]
pop bp
retf

; ---------------------------------------------

; partikkelisimulaatio inner

;       mov b[bx],al

; ---------------------------------------------

_CGA64KFLUSH:   ; (int buffseg)         ; linear 256*256*256

push bp
mov bp,sp
push ax,bx,cx,dx,ds,es,si,di

mov ax,[bp+6]   ; bufferin alkuoson seg. siin kaikki.
mov ds,ax

mov ax,0b800
mov es,ax
mov bx,12*256+3
mov bp,192*256+48
xor si,si
mov di,8+14*80
mov cx,200

l1:
    push cx
    mov cx,64
l0:
        lodsw
        mov dx,bp
        and dx,ax

        lodsw
        and ax,bx
        or ax,bx
        or al,ah

        stosb
   loop l0
   pop cx
   test cx,1
   jne >c0
        add di,8192-80
        jmp >c1
   c0:
        sub di,8192
   c1:
        add di,16
loop l1

pop di,si,es,ds,dx,cx,bx,ax,bp

retf

; ---------------------------------------------

_CGA256FLUSH:   ; (int buffseg);        ; linear 160x200x256

push bp
mov bp,sp
push ax,bx,cx,dx,ds,es,si,di

mov ax,[bp+6]   ; bufferin alkuoson seg. siin kaikki.
mov ds,ax

mov dx,[bp+8]   ; offsettaus
xchg dh,dl

mov ax,0b800
mov es,ax

xor si,si       ;   ds:0000       : 64000 tavun screenbufferi
xor di,di       ; b800:0000       : scrmem

mov dl,200      ; ruudun korkeus

l1:

xor bh,bh
mov bl,dl
add bl,dh
mov ah,b[bx+65024]      ; ds:65280-65480        rivikoht.konvtaululista

mov bh,ah               ; 256*konvtaululuku+64000
xor bl,bl
add bx,64000            ; ds:64000-             5kpl konversiotauluja
                        ;                       valitaan 65280- mukainen

mov bp,0f00f
mov cx,40

push dx
l0:
        lodsw
        xlat
        xchg ah,al
        xlat
        mov dx,bp
        and dx,ax

        lodsw
        xlat
        xchg ah,al
        xlat
        and ax,bp
        or ah,al

        mov al,dl
        or al,dh
        stosw

loop l0
pop dx

;lodsb
;xlat
;mov ah,al
;lodsb
;xlat
;and ax,bp
;or al,ah
;stosb


test dx,1               ; parillisen y:n jlkeen +8192-80
jne >c0
        add di,8192-80
        jmp >c1
c0:
        sub di,8192
c1:
dec dl
jne l1

pop di,si,es,ds,dx,cx,bx,ax,bp

retf



_div32:         ; int div32(int a,int b) = (a<<8)/b

push bp
mov bp,sp
push dx,bx

mov ax,[bp+6]

mov bx,[bp+8]
test bx,bx
jz >l0

        cwd             ; dxax=ax<<8;
        mov dl,ah
        cmp bx,dx
;       jl div32b       ;       ax*256 / bx > 65536
                        ;       ax / bx > 256
                        ;       ah > bx => kyt toista tapaa

        mov ah,al
        xor al,al

        idiv bx

l0:pop bx,dx,bp

retf




div32b:

        cwd
        idiv bx
        mov ah,al
        xor al,al
pop bx,dx,bp
retf

_grd_row:       ; Gouraud-innerluuppi.

push bp
mov bp,sp

; used reggzzzh:

push bx,cx,dx,bp,si,di,ds,es

les di,[bp+6]           ; outti   segm:off

mov ax,[bp+14]          ; x0
mov cx,[bp+16]          ; x1

mov dx,[bp+18]       ; jos x0<x1: alkuvri=c1
mov bp,[bp+20]          ; cstep

                ; - - - - varsinainen RuUZLZKx - - -

mov al,ah       ; x1>>=8;x2>>=8;
xor ah,ah
mov cl,ch
xor ch,ch

add di,ax       ; outti+=x1hi

sub cl,al       ; roowinpituus=(x2-x1)>>8       -> ax vapautuu
inc cx

l1:     mov al,dh
        stosb
        add dx,bp
        loop l1

pop es,ds,di,si,bp,dx,cx,bx,bp

retf

; -------------

_clrbuff:

push bp
mov bp,sp
push es,di,cx

        mov di,[bp+6]
        mov es,di
        xor di,di

        mov cx,16000
        xor ax,ax
        rep stosw

pop cx,di,es,bp

retf

