_ALLO64K:               ; ALLO64K();

push bx
mov ah,048
mov bx,4095             ; "vhn vaille 64k"
int 021
if c xor ax,ax          ; palauttaa nollan jos ei onnistunut
pop bx                  ; muussatapauksessa segmentin numeron
retf

_SCRMODE:               ; SCRMODE(int monesko);
push bp
mov bp,sp
mov ax,[bp+6]
push bx
xor bx,bx
int 010
pop bx,bp
xor ax,ax
retf

_MSFREE:                ; MSFREE(int segment);
push bp
mov bp,sp
push es
mov ax,[bp+6]
mov es,ax
mov ah,049
int 021
pop es,bp
retf

_ALLOTEST:      ; (int *buffer) returns int buff_offset from seg

push bp
mov bp,sp
mov ax,[bp+6]
pop bp
retf

; ---------------------------------------------

_CGA256FLUSH:   ; (int buffseg);

push bp
mov bp,sp
push ax,bx,cx,dx,ds,es,si,di

mov ax,[bp+6]   ; bufferin alkuoson seg. siin kaikki.
mov ds,ax

mov ax,0b800
mov es,ax

xor si,si       ;   ds:0000       : 64000 tavun screenbufferi
xor di,di       ; b800:0000       : scrmem

mov dx,200      ; ruudun korkeus

l1:

push dx

mov bx,dx
; add bl,jokualussarandomoituvakio?
mov ah,b[bx+65280]      ; ds:65280-65480        rivikoht.konvtaululista

mov bh,ah               ; 256*konvtaululuku+64000
xor bl,bl
add bx,64000            ; ds:64000-             5kpl konversiotauluja
                        ;                       valitaan 65280- mukainen

mov dx,00c03
mov bp,0c030
mov cx,80

l0:

lodsb           ; pix #1
xlat
mov ah,al
lodsb           ; pix #2
xlat            ;               pix1&2 -> ah.al
and ax,bp       ; bp = 11 00 00 00 | 00 11 00 00
or ah,al

lodsb           ; pix #3
xlat
and al,dh       ; dx = 00 00 11 00 | 00 00 00 11
or ah,al

lodsb           ; pix #4
xlat
and al,dl
or ah,al

mov al,ah
stosb

loop l0

pop dx

test dx,1               ; parillisen y:n jlkeen +8192-80
jne >c0
        add di,8192-80
        jmp >c1
c0:
        sub di,8192
c1:
dec dx
jne l1

pop di,si,es,ds,dx,cx,bx,ax,bp

retf

