; grd_row(far *outti, far *paletti, int x1, int x2, int c1, int c2);

_div32:         ; int div32(int a,int b) = (a<<8)/b

push bp
mov bp,sp
push dx,bx

mov ax,[bp+6]

mov bx,[bp+8]
test bx,bx
jz >l0

        cwd             ; dxax=ax<<8;
        mov dl,ah
        cmp bx,dx
;       jl div32b       ;       ax*256 / bx > 65536
                        ;       ax / bx > 256
                        ;       ah > bx => kyt toista tapaa

        mov ah,al
        xor al,al

        idiv bx

l0:pop bx,dx,bp

retf

div32b:

        cwd
        idiv bx
        mov ah,al
        xor al,al
pop bx,dx,bp
retf

_grd_row:       ; Gouraud-innerluuppi.

push bp
mov bp,sp

; used reggzzzh:

push bx,cx,dx,bp,si,di,ds,es

les di,[bp+6]           ; outti   segm:off
lds bx,[bp+10]          ; paletti segm:off

mov ax,[bp+14]          ; x0
mov cx,[bp+16]          ; x1

;cmp ax,bx
;jc >l0
;mov dx,[bp+20]          ; jos x0>x1: alkuvri=c2
;xchg ax,cx
;jmp >l1

mov dx,[bp+18]       ; jos x0<x1: alkuvri=c1
mov bp,[bp+20]          ; cstep

                ; - - - - varsinainen RuUZLZKx - - -

mov al,ah       ; x1>>=8;x2>>=8;
xor ah,ah
mov cl,ch
xor ch,ch

add di,ax       ; outti+=x1hi

sub cl,al       ; roowinpituus=(x2-x1)>>8       -> ax vapautuu
inc cx

l1:     mov al,dh
        xlat            ; al=[bx+dh]

        stosb

        ;or [di],al      ; [di]=[al]; di++;
        ;inc di          ; transparenssi!!!

        add dx,bp       ; dx+=cstep;
        loop l1

pop es,ds,di,si,bp,dx,cx,bx,bp

retf

; -------------

_clrbuff:

push bp
mov bp,sp
push es,di,cx

        les di,[bp+6]

        mov cx,1000
        xor ax,ax
        rep stosw

pop cx,di,es,bp

retf

; -------------

_buff2scr:

push bp
mov bp,sp

push ds,si,es,di,cx,bx

        lds si,[bp+6]
        mov bx,[bp+10]  ; lisysmr
        add si,bx

        mov ax,0b800
        mov es,ax

        mov di,bx
        add di,bx
        inc di

        mov cx,2000
        sub cx,bx

l2:     movsb                   ; 18
        inc di                  ; 2
        loop l2                 ; 17    -> 37

pop bx,cx,di,es,si,ds,bp

retf

; doomi

rtaulisa: dw 0


; toinen bufferinclearaustapa: tunneli
; tunbuff(*bufferi,*napajabitmap,offsetti)
;       napajabitmap = 80x25 napataulu mitassa [r]32 x [a]64  4096bytes
;                      tmn jlkeen 4096 byten verran bitmappia.

; paletillinen tunneli (flamea varten)

;

; -------------

_tunbuff:

push bp       ; stack, bitmaptaulu
mov bp,sp

push es,di    ; outbufferi
push ds,bx,dx ; napataulu, siirtym
push si,cx ; tmp

    les di,[bp+6]   ; es:di = outbufferi
    lds bx,[bp+10]  ; ds:bx = napataulu
    mov dx,[bp+14]  ; dx = taulusiirtym

    mov bp,bx
    add bp,4096     ; ds:bp = bitmaptaulu

    mov cx,2000-80

    l1: mov si,[bx]     ; ax, si, cx = temp
        add bx,2

        add si,dx
        and si,4095
        add si,bp

        movsb           ; while(cx--) [di++]=[bp][([bx+=2]+dx)&4095];
        loop l1

pop cx,si
pop dx,bx,ds
pop di,es
pop bp

retf


_paltunbuff:

push bp       ; stack, bitmaptaulu
mov bp,sp

push es,di    ; outbufferi
push ds,bx,dx ; napataulu, siirtym
push si,cx ; tmp

    les di,[bp+6]   ; es:di = outbufferi
    mov dx,[bp+14]  ; dx = bitmapsiirtym
    lds bp,[bp+10]  ; ds:bp = tauluryps
                    ; 0-4095     napa    (80x25x2)
                    ; 4096-8191  bitmap  (256x16x1)
                    ; 8192-      paletti (256xn)

    mov si,bp       ; bitmaptaulu tulee napataulun jlkeen
    add si,4096
    cs mov [bto+1],si   ; vai 2?

    add si,4096     ; palettikohta
    mov bx,si

    mov cx,2000-80

    l1: mov si,[bp]     ; ax, si, cx = temp
        add bp,2

        add si,dx
        and si,4095
bto:    add si,0ffff

        lodsb

        xlat
        stosb

        loop l1

pop cx,si
pop dx,bx,ds
pop di,es
pop bp

retf

_cls:
push bp
mov bp,sp
push ax,es,di,cx

les di,[bp+6]
mov ax,[bp+10]

mov cx,2000
rep stosw

pop cx,di,es,ax,bp
retf

ktrylaper160: db 0

_memcopy:

push bp
mov bp,sp
push es,di,ds,si,cx

        lds si,[bp+6]
        les di,[bp+10]
        mov cx,[bp+14]
        rep movsw

pop cx,si,ds,di,es,bp
retf

_copy80:        ; *src,*dest,off

push bp
mov bp,sp
push es,di,ds,si,cx,dx,ax

        lds si,[bp+6]
        les di,[bp+10]
        mov ax,[bp+14]
        mov dx,25

l0:     mov cx,80
        sub cx,ax
        rep movsb

        sub di,80
        mov cx,ax
        rep movsb

        add di,80
        dec dx
        jne l0

pop ax,dx,cx,si,ds,di,es,bp
retf


_xscroll:

push es,ds, cx,dx, si,di

mov dx,0b800
mov ds,dx
mov es,dx
mov dx,21
mov si,(4*160)+2
mov di,(4*160)

l0:
  mov cx,79
  rep movsw
  sub si,160
  movsw
  add si,160
  dec dx
  jne l0

pop di,si, dx,cx, ds,es

retf

; dualplane:
;       plane1:   si
;       plane2:   bp
;       outbuffer: di = 0b800
;       siirtym: dl

_dualplane:     ; (*plane1,*plane2,off)         off=1..80

;     DUAL PLANE

; plane1: si
; plane2: bp
; output: di

; I  cx    askelta
;    siirtym -160
; II 80-cx askelta
;    siirtym +160

; ruutu:    dl + | raja | + 80-dl
;           kun dl vhenee niin si kasvaa (si=si+80-dl)

push bp
mov bp,sp
push ax,bx,cx,dx,si,di,ds,es

lds si,[bp+6]   ; plane1 start
lds bx,[bp+10]  ; plane2 start
mov dx,[bp+14]  ; plane1 offset
mov ax,[bp+16]  ; plane2 offset
mov bp,bx

PLANEPIT EQU 7680
add bx,PLANEPIT ; plane2 alaraja
add bp,ax       ; plane2 screenstart

mov ax,0b800
mov es,ax
xor di,di

add si,160
sub si,dx
sub si,dx

mov dh,25

rivialku:

xor ch,ch
mov cl,dl   ; dl=siirtymvaihe (1-79)

l0a:lodsw
    cmp ax,01fd
    je plane2a
    add bp,2
    stosw
loop l0a

l1a:
sub si,160

clc
cmp bx,bp
if na sub bp,PLANEPIT

mov cl,80
sub cl,dl
je l1b

l0b:lodsw
    cmp ax,01fd
    je plane2b
    add bp,2
    stosw
loop l0b

l1b:
add si,160

clc
cmp bx,bp
if na sub bp,PLANEPIT   ; na = cf tai zf

dec dh
jne rivialku

pop es,ds,di,si,dx,cx,bx,ax,bp
retf

plane2a:
   ds mov ax,[bp]
   stosw
   add bp,2
loop l0a
jmp l1a

plane2b:
   ds mov ax,[bp]
   stosw
   add bp,2
loop l0b
jmp l1b

_flushdouble:   ; (*buffer8050,*outbuf);

push bp
mov bp,sp
push ds,es,si,di,cx,ax,dx

lds si,[bp+6]
les di,[bp+10]
mov dl,25

l1: mov cx,80
l0: lodsb
    mov ah,[si+79]
    and ax,0ff0
    or al,ah
    inc di
    stosb
loop l0
    add si,80
    dec dl
jne l1

pop dx,ax,cx,di,si,es,ds,bp
retf

_lineinner:
; lineinner(*bufu, int x1-x0, char vari, int  sta1-1, int  sta2, int steppi);
;           es:di   cx         ax          si         bp         bl

push bp
mov bp,sp
push ax,cx,dx,si,di

les di,[bp+6]
mov cx,[bp+10]
mov ax,[bp+12]
mov si,[bp+14]
mov bx,[bp+18]
mov bp,[bp+16]

l0:     stosb           ; *bufu=vari;
        add di,si       ; bufu+=sta-1;
        clc
        add ah,bl       ; lp2+=steppi;
        jc >p0          ; if yli ->
        loop l0
        jmp p1

p0:     add di,bp       ; bufu+=sta2;
        loop l0
        jmp p1

p1:     pop di,si,dx,cx,ax,bp
        retf

_adlibput:      ; rekisteri, sislt

 push bp
 mov bp,sp
 push ax,cx,dx

 mov ax,[bp+6]
 mov dx,[bp+8]
 mov ah,dl

 mov dx,0388
 out dx,al
   mov cx,6
   l0:in al,dx
   loop l0
 inc dx
 mov al,ah
 out dx,al
   dec dx
   mov cx,35
   l1:in al,dx
   loop l1

 pop dx,cx,ax,bp

retf

_copy2scr:

  push bp
  mov bp,sp
  push ds,es,si,di,cx
  lds si,[bp+6]
  mov di,0b800
  mov es,di
  xor di,di
  mov cx,2000
  rep movsw
  pop cx,di,si,es,ds,bp
retf

_copyastrsp:

push bp
mov bp,sp
push es,di,ds,si,cx,ax

        lds si,[bp+6]
        les di,[bp+10]
        mov cx,2000
l0:             lodsw
                test ah,ah
                if e mov ax,01fd
                stosw
        loop l0

pop ax,cx,si,ds,di,es,bp
retf
